<?php

namespace Deployer;

require_once 'inc/database.php';

desc('create database configuration file');
task('setup:createDbConfig', function () {
    try {
        if (!has('db_conf_path') || !strlen(get('db_conf_path'))) {
            throw new \RuntimeException('missing db_conf_path option, task stopped');
        }
        if (!test('[ -d $(dirname "{{db_conf_path}}") ]')) {
            run('mkdir -p $(dirname "{{db_conf_path}}")');
            if (!test('[ -d $(dirname "{{db_conf_path}}") ]')) {
                throw new \RuntimeException('unable to create configured path {{db_conf_path}}, task stopped');
            }
        }
        if (!test("[ -f {{db_conf_path}} ]")) {
            run("touch {{db_conf_path}}");
        }
        if (test("[ -f {{db_conf_path}} ]")) {
            run('printf "[client]\nhost=\"'.ask('database host', 'localhost').'\"\nport=\"'.ask('database port', '3306').'\"\nuser=\"'.ask('database user').'\"\npassword=\"'.askHiddenResponse('database password').'\"\n\n[mysql]\ndatabase=\"'.ask('database name').'\"" > {{db_conf_path}}');
            info('config successful created');
        } else {
            throw new \RuntimeException('can not create {{db_conf_path}}, task stopped');
        }
    } catch(\RuntimeException $e) {
        warning($e->getMessage());
    }
});
